'From Squeak3.10.2 of ''5 June 2008'' [latest update: #7179] on 4 December 2014 at 2:42:25 pm'!
VariableNode subclass: #BB1RoleNode
	instanceVariableNames: 'receiver arguments selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BB1IDE-Support'!

!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 11/25/2011 10:00'!
asVariable: roleName contextName: ctxNam
	| arg1 |
	comment := nil.
	receiver := VariableNode new
				name: 'self'
				key: #BB1ContextStack -> BB1ContextStack
				code: -4.
	selector := SelectorNode new comment: nil;
				 key: #playerForRole: code: -5.
	arg1 := LiteralVariableNode new.
	arg1 key: roleName asSymbol code: LdLitType negated.
	arg1 name: roleName.
	arguments := OrderedCollection with: arg1.!
]style[(11 10 12 92 15 4 15 248)bf3,f3,bf3,f3,f2,f3,f2,f3! !

!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 10/26/2011 17:04'!
contextClass
	^key value! !

!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 10/26/2011 17:30'!
receiver 
	^receiver! !

!BB1RoleNode methodsFor: 'accessing' stamp: 'Trygve 10/27/2011 14:44'!
roleName
	^arguments first key! !


!BB1RoleNode methodsFor: 'code generation' stamp: 'Trygve 10/26/2011 17:35'!
emitForValue: stack on: strm
	pc := 0.
	receiver ~~ nil ifTrue: [receiver emitForValue: stack on: strm].
	arguments do: [:argument | argument emitForValue: stack on: strm].
	selector
		emit: stack
		args: arguments size
		on: strm
		super: receiver == NodeSuper.
	pc _ strm position.! !

!BB1RoleNode methodsFor: 'code generation' stamp: 'TRee 3/28/2010 15:43'!
sizeForValue: encoder
	| total argSize |
	receiver == NodeSuper
		ifTrue: [selector _ selector copy "only necess for splOops"].
	total _ selector size: encoder args: arguments size super: receiver == NodeSuper.
	receiver == nil 
		ifFalse: [total _ total + (receiver sizeForValue: encoder)].
	arguments do: 
					[:arg | 
					argSize _ arg sizeForValue: encoder.
					total _ total + argSize.
					argSize].
	^total! !


!BB1RoleNode methodsFor: 'printing' stamp: 'Trygve 8/14/2013 20:36'!
printOn: aStream indent: level
	aStream 
		nextPutAll: arguments printString , ' ' , selector printString.
		
	! !
