'From Squeak4.5 of 19 February 2014 [latest update: #13680] on 7 December 2014 at 11:50:55 am'!


!Encoder methodsFor: '*BB1IDE' stamp: 'Trygve 12/4/2014 14:35'!
init: aCue notifying: anObject
	"The use of the variable requestor is a bit confusing here. This is
	*not* the original requestor, which is available through the cue.
	It's the Parser instance that is using the encoder."

	self setCue: aCue.
	requestor := anObject.
	nTemps := 0.
	supered := false.
	self initScopeAndLiteralTables.
 
	" Begin DCI special. "
	cue getClass name = #RoleMethods "(cue getClass superclass == BB1RuntimeRole and: [cue getClass roleName notNil])"
		ifTrue: 
			["(cue getClass contextClass collaboratorsFor: cue getClass roleName)
						, #(cc))"
		#(#AMOUNT #DESTINATIONACCOUNT #SOURCEACCOUNT #cc)
				do: 
				[:roleName |
						scopeTable 
							at: roleName
							put: (BB1RoleNode new 
								asVariable: roleName 
								contextName: #Dummy "class contextName")]].
	" End DCI special. "

	cue getClass variablesAndOffsetsDo:
		[:variable "<String|CFieldDefinition>" :offset "<Integer|nil>" |
		offset isNil
			ifTrue: [scopeTable at: variable name put: (FieldNode new fieldDefinition: variable)]
			ifFalse: [scopeTable
						at: variable
						put: (offset >= 0
								ifTrue: [InstanceVariableNode new
											name: variable index: offset]
								ifFalse: [MaybeContextInstanceVariableNode new
											name: variable index: offset negated])]].
	cue context ~~ nil ifTrue:
		[| homeNode |
		 homeNode := self bindTemp: self doItInContextName.
		 "0th temp = aContext passed as arg"
		 cue context tempNames withIndexDo:
			[:variable :index|
			scopeTable
				at: variable
				put: (MessageAsTempNode new
						receiver: homeNode
						selector: #namedTempAt:
						arguments: (Array with: (self encodeLiteral: index))
						precedence: 3
						from: self)]].
	sourceRanges := Dictionary new: 32.
	globalSourceRanges := OrderedCollection new: 32
! !

!Encoder methodsFor: '*BB1IDE' stamp: 'Trygve 12/7/2014 11:31'!
scopeTableAt: key
	^scopeTable at: key!
]style[(13 1 4 20)f3b,f3,f3i,f3! !

!Encoder methodsFor: '*BB1IDE' stamp: 'Trygve 12/7/2014 11:32'!
scopeTableAt: key put: value
	scopeTable at: key put: value.!
]style[(13 1 4 4 1 6 31)f3b,f3,f3i,f3b,f3,f3i,f3! !
